## gstaudio gstaudio — Support library for audio elements |

## Functions

void | (*GstAudioFormatPack) ()
void | (*GstAudioFormatUnpack) ()
void | gst_audio_info_init ()
gboolean | gst_audio_info_from_caps ()
GstCaps * | gst_audio_info_to_caps ()
gboolean | gst_audio_info_convert ()
const GstAudioFormatInfo * | gst_audio_format_get_info ()
GstAudioInfo * | gst_audio_info_copy ()
void | gst_audio_info_free ()
GstAudioInfo * | gst_audio_info_new ()
void | gst_audio_info_set_format ()
gboolean | gst_audio_info_is_equal ()
GstAudioFormat | gst_audio_format_build_integer ()
void | gst_audio_format_fill_silence ()
GstAudioFormat | gst_audio_format_from_string ()
const gchar * | gst_audio_format_to_string ()
#define | GST_AUDIO_FORMAT_INFO_DEPTH()
#define | GST_AUDIO_FORMAT_INFO_ENDIANNESS()
#define | GST_AUDIO_FORMAT_INFO_FLAGS()
#define | GST_AUDIO_FORMAT_INFO_FORMAT()
#define | GST_AUDIO_FORMAT_INFO_IS_FLOAT()
#define | GST_AUDIO_FORMAT_INFO_IS_INTEGER()
#define | GST_AUDIO_FORMAT_INFO_IS_BIG_ENDIAN()
#define | GST_AUDIO_FORMAT_INFO_IS_LITTLE_ENDIAN()
#define | GST_AUDIO_FORMAT_INFO_IS_SIGNED()
#define | GST_AUDIO_FORMAT_INFO_NAME()
#define | GST_AUDIO_FORMAT_INFO_WIDTH()
#define | GST_AUDIO_INFO_BPF()
#define | GST_AUDIO_INFO_BPS()
#define | GST_AUDIO_INFO_CHANNELS()
#define | GST_AUDIO_INFO_DEPTH()
#define | GST_AUDIO_INFO_FLAGS()
#define | GST_AUDIO_INFO_FORMAT()
#define | GST_AUDIO_INFO_NAME()
#define | GST_AUDIO_INFO_POSITION()
#define | GST_AUDIO_INFO_RATE()
#define | GST_AUDIO_INFO_WIDTH()
#define | GST_AUDIO_INFO_ENDIANNESS()
#define | GST_AUDIO_INFO_IS_BIG_ENDIAN()
#define | GST_AUDIO_INFO_IS_FLOAT()
#define | GST_AUDIO_INFO_IS_INTEGER()
#define | GST_AUDIO_INFO_IS_LITTLE_ENDIAN()
#define | GST_AUDIO_INFO_IS_SIGNED()
#define | GST_AUDIO_INFO_IS_UNPOSITIONED()
#define | GST_AUDIO_INFO_IS_VALID()
#define | GST_AUDIO_INFO_LAYOUT()
#define | GST_FRAMES_TO_CLOCK_TIME()
#define | GST_CLOCK_TIME_TO_FRAMES()
#define | GST_AUDIO_NE()
#define | GST_AUDIO_OE()
#define | GST_AUDIO_CAPS_MAKE()
GstBuffer * | gst_audio_buffer_clip ()

## Types and Values

enum | GstAudioFlags
enum | GstAudioFormat
enum | GstAudioFormatFlags
struct | GstAudioFormatInfo
struct | GstAudioInfo
enum | GstAudioLayout
enum | GstAudioPackFlags
#define | GST_META_TAG_AUDIO_STR
#define | GST_META_TAG_AUDIO_CHANNELS_STR
#define | GST_AUDIO_RATE_RANGE
#define | GST_AUDIO_CHANNELS_RANGE
#define | GST_AUDIO_FORMATS_ALL
#define | GST_AUDIO_DEF_RATE
#define | GST_AUDIO_DEF_CHANNELS
#define | GST_AUDIO_DEF_FORMAT

## Includes

    #include <gst/audio/audio.h>

## Description

This library contains some helper functions for audio elements.

## Functions

### GstAudioFormatPack ()

    void
    (*GstAudioFormatPack) (const GstAudioFormatInfo *info,
                           GstAudioPackFlags flags,
                           const gpointer src,
                           gpointer data,
                           gint length);

Packs `length` samples from `src` to the data array in format `info` . The samples from source have each channel interleaved and will be packed into `data` .

#### Parameters

info | a GstAudioFormatInfo |
src | a source array. | [array][element-type guint8]
data | pointer to the destination data. | [array][element-type guint8]
length | the amount of samples to pack. |

### GstAudioFormatUnpack ()

    void
    (*GstAudioFormatUnpack) (const GstAudioFormatInfo *info,
                             GstAudioPackFlags flags,
                             gpointer dest,
                             const gpointer data,
                             gint length);

Unpacks `length` samples from the given data of format `info` . The samples will be unpacked into `dest` which each channel interleaved. `dest` should at least be big enough to hold `length` * channels * size(unpack_format) bytes.

#### Parameters

info | a GstAudioFormatInfo |
dest | a destination array. | [array][element-type guint8]
data | pointer to the audio data. | [array][element-type guint8]
length | the amount of samples to unpack. |

### gst_audio_info_init ()

    void
    gst_audio_info_init (GstAudioInfo *info);

Initialize `info` with default values.

#### Parameters

info | a GstAudioInfo |

### gst_audio_info_from_caps ()

    gboolean
    gst_audio_info_from_caps (GstAudioInfo *info,
                              const GstCaps *caps);

Parse `caps` and update `info` .

#### Parameters

info | a GstAudioInfo |
caps | a GstCaps |

#### Returns

TRUE if `caps` could be parsed

### gst_audio_info_to_caps ()

    GstCaps *
    gst_audio_info_to_caps (const GstAudioInfo *info);

Convert the values of `info` into a GstCaps.

#### Parameters

info | a GstAudioInfo |

#### Returns

the new GstCaps containing the info of `info` .

[transfer full]

### gst_audio_info_convert ()

    gboolean
    gst_audio_info_convert (const GstAudioInfo *info,
                            GstFormat src_fmt,
                            gint64 src_val,
                            GstFormat dest_fmt,
                            gint64 *dest_val);

Converts among various GstFormat types. This function handles GST_FORMAT_BYTES, GST_FORMAT_TIME, and GST_FORMAT_DEFAULT. For raw audio, GST_FORMAT_DEFAULT corresponds to audio frames. This function can be used to handle pad queries of the type GST_QUERY_CONVERT.

#### Parameters

info | a GstAudioInfo |
src_fmt | GstFormat of the `src_val` |
src_val | value to convert |
dest_fmt | GstFormat of the `dest_val` |
dest_val | pointer to destination value |

#### Returns

TRUE if the conversion was successful.

### gst_audio_format_get_info ()

    const GstAudioFormatInfo *
    gst_audio_format_get_info (GstAudioFormat format);

Get the GstAudioFormatInfo for `format`

#### Parameters

format | a GstAudioFormat |

#### Returns

The GstAudioFormatInfo for `format` .

### gst_audio_info_copy ()

    GstAudioInfo *
    gst_audio_info_copy (const GstAudioInfo *info);

Copy a GstAudioInfo structure.

#### Parameters

info | a GstAudioInfo |

#### Returns

a new GstAudioInfo. free with gst_audio_info_free.

### gst_audio_info_free ()

    void
    gst_audio_info_free (GstAudioInfo *info);

Free a GstAudioInfo structure previously allocated with `gst_audio_info_new()` or `gst_audio_info_copy()`.

#### Parameters

info | a GstAudioInfo |

### gst_audio_info_new ()

    GstAudioInfo *
    gst_audio_info_new (void);

Allocate a new GstAudioInfo that is also initialized with `gst_audio_info_init()`.

#### Returns

a new GstAudioInfo. free with `gst_audio_info_free()`.

### gst_audio_info_set_format ()

    void
    gst_audio_info_set_format (GstAudioInfo *info,
                               GstAudioFormat format,
                               gint rate,
                               gint channels,
                               const GstAudioChannelPosition *position);

Set the default info for the audio info of `format` and `rate` and `channels` .

Note: This initializes `info` first, no values are preserved.

#### Parameters

info | a GstAudioInfo |
format | the format |
rate | the samplerate |
channels | the number of channels |
position | the channel positions |

### gst_audio_info_is_equal ()

    gboolean
    gst_audio_info_is_equal (const GstAudioInfo *info,
                             const GstAudioInfo *other);

Compares two GstAudioInfo and returns whether they are equal or not

#### Parameters

info | a GstAudioInfo |
other | a GstAudioInfo |

#### Returns

`TRUE` if `info` and `other` are equal, else `FALSE`.

Since 1.2

### gst_audio_format_build_integer ()

    GstAudioFormat
    gst_audio_format_build_integer (gboolean sign,
                                    gint endianness,
                                    gint width,
                                    gint depth);

Construct a GstAudioFormat with given parameters.

#### Parameters

sign | signed or unsigned format |
endianness | G_LITTLE_ENDIAN or G_BIG_ENDIAN |
width | amount of bits used per sample |
depth | amount of used bits in `width` |

#### Returns

a GstAudioFormat or GST_AUDIO_FORMAT_UNKNOWN when no audio format exists with the given parameters.

### gst_audio_format_fill_silence ()

    void
    gst_audio_format_fill_silence (const GstAudioFormatInfo *info,
                                   gpointer dest,
                                   gsize length);

Fill `length` bytes in `dest` with silence samples for `info` .

#### Parameters

info | a GstAudioFormatInfo |
dest | a destination to fill. | [array length=length][element-type guint8]
length | the length to fill |

### gst_audio_format_from_string ()

    GstAudioFormat
    gst_audio_format_from_string (const gchar *format);

Convert the `format` string to its GstAudioFormat.

#### Parameters

format | a format string |

#### Returns

the GstAudioFormat for `format` or GST_AUDIO_FORMAT_UNKNOWN when the string is not a known format.

### gst_audio_format_to_string ()

    const gchar *
    gst_audio_format_to_string (GstAudioFormat format);

### GST_AUDIO_FORMAT_INFO_DEPTH()

    #define GST_AUDIO_FORMAT_INFO_DEPTH(info)            ((info)->depth)

### GST_AUDIO_FORMAT_INFO_ENDIANNESS()

    #define GST_AUDIO_FORMAT_INFO_ENDIANNESS(info)       ((info)->endianness)

### GST_AUDIO_FORMAT_INFO_FLAGS()

    #define GST_AUDIO_FORMAT_INFO_FLAGS(info)            ((info)->flags)

### GST_AUDIO_FORMAT_INFO_FORMAT()

    #define GST_AUDIO_FORMAT_INFO_FORMAT(info)           ((info)->format)

### GST_AUDIO_FORMAT_INFO_IS_FLOAT()

    #define GST_AUDIO_FORMAT_INFO_IS_FLOAT(info)         !!((info)->flags & GST_AUDIO_FORMAT_FLAG_FLOAT)

### GST_AUDIO_FORMAT_INFO_IS_INTEGER()

    #define GST_AUDIO_FORMAT_INFO_IS_INTEGER(info)       !!((info)->flags & GST_AUDIO_FORMAT_FLAG_INTEGER)

### GST_AUDIO_FORMAT_INFO_IS_BIG_ENDIAN()

    #define GST_AUDIO_FORMAT_INFO_IS_BIG_ENDIAN(info)    ((info)->endianness == G_BIG_ENDIAN)

### GST_AUDIO_FORMAT_INFO_IS_LITTLE_ENDIAN()

    #define GST_AUDIO_FORMAT_INFO_IS_LITTLE_ENDIAN(info) ((info)->endianness == G_LITTLE_ENDIAN)

### GST_AUDIO_FORMAT_INFO_IS_SIGNED()

    #define GST_AUDIO_FORMAT_INFO_IS_SIGNED(info)        !!((info)->flags & GST_AUDIO_FORMAT_FLAG_SIGNED)

### GST_AUDIO_FORMAT_INFO_NAME()

    #define GST_AUDIO_FORMAT_INFO_NAME(info)             ((info)->name)

### GST_AUDIO_FORMAT_INFO_WIDTH()

    #define GST_AUDIO_FORMAT_INFO_WIDTH(info)            ((info)->width)

### GST_AUDIO_INFO_BPF()

    #define GST_AUDIO_INFO_BPF(info)             ((info)->bpf)

### GST_AUDIO_INFO_BPS()

    #define GST_AUDIO_INFO_BPS(info)             (GST_AUDIO_INFO_DEPTH(info) >> 3)

### GST_AUDIO_INFO_CHANNELS()

    #define GST_AUDIO_INFO_CHANNELS(info)        ((info)->channels)

### GST_AUDIO_INFO_DEPTH()

    #define GST_AUDIO_INFO_DEPTH(i)              (GST_AUDIO_FORMAT_INFO_DEPTH((i)->finfo))

### GST_AUDIO_INFO_FLAGS()

    #define GST_AUDIO_INFO_FLAGS(info)           ((info)->flags)

### GST_AUDIO_INFO_FORMAT()

    #define GST_AUDIO_INFO_FORMAT(i)             (GST_AUDIO_FORMAT_INFO_FORMAT((i)->finfo))

### GST_AUDIO_INFO_NAME()

    #define GST_AUDIO_INFO_NAME(i)               (GST_AUDIO_FORMAT_INFO_NAME((i)->finfo))

### GST_AUDIO_INFO_POSITION()

    #define GST_AUDIO_INFO_POSITION(info,c)      ((info)->position[c])

### GST_AUDIO_INFO_RATE()

    #define GST_AUDIO_INFO_RATE(info)            ((info)->rate)

### GST_AUDIO_INFO_WIDTH()

    #define GST_AUDIO_INFO_WIDTH(i)              (GST_AUDIO_FORMAT_INFO_WIDTH((i)->finfo))

### GST_AUDIO_INFO_ENDIANNESS()

    #define GST_AUDIO_INFO_ENDIANNESS(i)         (GST_AUDIO_FORMAT_INFO_ENDIANNESS((i)->finfo))

### GST_AUDIO_INFO_IS_BIG_ENDIAN()

    #define GST_AUDIO_INFO_IS_BIG_ENDIAN(i)      (GST_AUDIO_FORMAT_INFO_IS_BIG_ENDIAN((i)->finfo))

### GST_AUDIO_INFO_IS_FLOAT()

    #define GST_AUDIO_INFO_IS_FLOAT(i)           (GST_AUDIO_FORMAT_INFO_IS_FLOAT((i)->finfo))

### GST_AUDIO_INFO_IS_INTEGER()

    #define GST_AUDIO_INFO_IS_INTEGER(i)         (GST_AUDIO_FORMAT_INFO_IS_INTEGER((i)->finfo))

### GST_AUDIO_INFO_IS_LITTLE_ENDIAN()

    #define GST_AUDIO_INFO_IS_LITTLE_ENDIAN(i)   (GST_AUDIO_FORMAT_INFO_IS_LITTLE_ENDIAN((i)->finfo))

### GST_AUDIO_INFO_IS_SIGNED()

    #define GST_AUDIO_INFO_IS_SIGNED(i)          (GST_AUDIO_FORMAT_INFO_IS_SIGNED((i)->finfo))

### GST_AUDIO_INFO_IS_UNPOSITIONED()

    #define GST_AUDIO_INFO_IS_UNPOSITIONED(info) ((info)->flags & GST_AUDIO_FLAG_UNPOSITIONED)

### GST_AUDIO_INFO_IS_VALID()

    #define GST_AUDIO_INFO_IS_VALID(i)           ((i)->finfo != NULL && (i)->rate > 0 && (i)->channels > 0 && (i)->bpf > 0)

### GST_AUDIO_INFO_LAYOUT()

    #define GST_AUDIO_INFO_LAYOUT(info)          ((info)->layout)

### GST_FRAMES_TO_CLOCK_TIME()

    #define             GST_FRAMES_TO_CLOCK_TIME(frames, rate)

Calculate clocktime from sample `frames` and `rate` .

#### Parameters

frames | sample frames |
rate | sampling rate |

### GST_CLOCK_TIME_TO_FRAMES()

    #define             GST_CLOCK_TIME_TO_FRAMES(clocktime, rate)

Calculate frames from `clocktime` and sample `rate` .

#### Parameters

clocktime | clock time |
rate | sampling rate |

### GST_AUDIO_NE()

    # define GST_AUDIO_NE(s) G_STRINGIFY(s)"LE"

Turns audio format string `s` into the format string for native endianness.

#### Parameters

s | format string without endianness marker |

### GST_AUDIO_OE()

    # define GST_AUDIO_OE(s) G_STRINGIFY(s)"BE"

Turns audio format string `s` into the format string for other endianness.

#### Parameters

s | format string without endianness marker |

### GST_AUDIO_CAPS_MAKE()

    #define             GST_AUDIO_CAPS_MAKE(format)

Generic caps string for audio, for use in pad templates.

#### Parameters

format | string format that describes the sample layout, as string (e.g. "S16LE", "S8", etc.) |

### gst_audio_buffer_clip ()

    GstBuffer *
    gst_audio_buffer_clip (GstBuffer *buffer,
                           GstSegment *segment,
                           gint rate,
                           gint bpf);

Clip the buffer to the given `GstSegment`.

After calling this function the caller does not own a reference to `buffer` anymore.

#### Parameters

buffer | The buffer to clip. | [transfer full]
segment | Segment in `GST_FORMAT_TIME` or `GST_FORMAT_DEFAULT` to which the buffer should be clipped. |
rate | sample rate. |
bpf | size of one audio frame in bytes. This is the size of one sample channels. |

#### Returns

`NULL` if the buffer is completely outside the configured segment, otherwise the clipped buffer is returned.

If the buffer has no timestamp, it is assumed to be inside the segment and is not clipped.

[transfer full]

## Types and Values

### enum GstAudioFlags

Extra audio flags

#### Members

GST_AUDIO_FLAG_NONE | no valid flag |
GST_AUDIO_FLAG_UNPOSITIONED | the position array explicitly contains unpositioned channels. |

### enum GstAudioFormat

Enum value describing the most common audio formats.

#### Members

GST_AUDIO_FORMAT_UNKNOWN | unknown or unset audio format |
GST_AUDIO_FORMAT_ENCODED | encoded audio format |
GST_AUDIO_FORMAT_S8 | 8 bits in 8 bits, signed |
GST_AUDIO_FORMAT_U8 | 8 bits in 8 bits, unsigned |
GST_AUDIO_FORMAT_S16LE | 16 bits in 16 bits, signed, little endian |
GST_AUDIO_FORMAT_S16BE | 16 bits in 16 bits, signed, big endian |
GST_AUDIO_FORMAT_U16LE | 16 bits in 16 bits, unsigned, little endian |
GST_AUDIO_FORMAT_U16BE | 16 bits in 16 bits, unsigned, big endian |
GST_AUDIO_FORMAT_S24_32LE | 24 bits in 32 bits, signed, little endian |
GST_AUDIO_FORMAT_S24_32BE | 24 bits in 32 bits, signed, big endian |
GST_AUDIO_FORMAT_U24_32LE | 24 bits in 32 bits, unsigned, little endian |
GST_AUDIO_FORMAT_U24_32BE | 24 bits in 32 bits, unsigned, big endian |
GST_AUDIO_FORMAT_S32LE | 32 bits in 32 bits, signed, little endian |
GST_AUDIO_FORMAT_S32BE | 32 bits in 32 bits, signed, big endian |
GST_AUDIO_FORMAT_U32LE | 32 bits in 32 bits, unsigned, little endian |
GST_AUDIO_FORMAT_U32BE | 32 bits in 32 bits, unsigned, big endian |
GST_AUDIO_FORMAT_S24LE | 24 bits in 24 bits, signed, little endian |
GST_AUDIO_FORMAT_S24BE | 24 bits in 24 bits, signed, big endian |
GST_AUDIO_FORMAT_U24LE | 24 bits in 24 bits, unsigned, little endian |
GST_AUDIO_FORMAT_U24BE | 24 bits in 24 bits, unsigned, big endian |
GST_AUDIO_FORMAT_S20LE | 20 bits in 24 bits, signed, little endian |
GST_AUDIO_FORMAT_S20BE | 20 bits in 24 bits, signed, big endian |
GST_AUDIO_FORMAT_U20LE | 20 bits in 24 bits, unsigned, little endian |
GST_AUDIO_FORMAT_U20BE | 20 bits in 24 bits, unsigned, big endian |
GST_AUDIO_FORMAT_S18LE | 18 bits in 24 bits, signed, little endian |
GST_AUDIO_FORMAT_S18BE | 18 bits in 24 bits, signed, big endian |
GST_AUDIO_FORMAT_U18LE | 18 bits in 24 bits, unsigned, little endian |
GST_AUDIO_FORMAT_U18BE | 18 bits in 24 bits, unsigned, big endian |
GST_AUDIO_FORMAT_F32LE | 32-bit floating point samples, little endian |
GST_AUDIO_FORMAT_F32BE | 32-bit floating point samples, big endian |
GST_AUDIO_FORMAT_F64LE | 64-bit floating point samples, little endian |
GST_AUDIO_FORMAT_F64BE | 64-bit floating point samples, big endian |
GST_AUDIO_FORMAT_S16 | 16 bits in 16 bits, signed, native endianness |
GST_AUDIO_FORMAT_U16 | 16 bits in 16 bits, unsigned, native endianness |
GST_AUDIO_FORMAT_S24_32 | 24 bits in 32 bits, signed, native endianness |
GST_AUDIO_FORMAT_U24_32 | 24 bits in 32 bits, unsigned, native endianness |
GST_AUDIO_FORMAT_S32 | 32 bits in 32 bits, signed, native endianness |
GST_AUDIO_FORMAT_U32 | 32 bits in 32 bits, unsigned, native endianness |
GST_AUDIO_FORMAT_S24 | 24 bits in 24 bits, signed, native endianness |
GST_AUDIO_FORMAT_U24 | 24 bits in 24 bits, unsigned, native endianness |
GST_AUDIO_FORMAT_S20 | 20 bits in 24 bits, signed, native endianness |
GST_AUDIO_FORMAT_U20 | 20 bits in 24 bits, unsigned, native endianness |
GST_AUDIO_FORMAT_S18 | 18 bits in 24 bits, signed, native endianness |
GST_AUDIO_FORMAT_U18 | 18 bits in 24 bits, unsigned, native endianness |
GST_AUDIO_FORMAT_F32 | 32-bit floating point samples, native endianness |
GST_AUDIO_FORMAT_F64 | 64-bit floating point samples, native endianness |

### enum GstAudioFormatFlags

The different audio flags that a format info can have.

#### Members

GST_AUDIO_FORMAT_FLAG_INTEGER | integer samples |
GST_AUDIO_FORMAT_FLAG_FLOAT | float samples |
GST_AUDIO_FORMAT_FLAG_SIGNED | signed samples |
GST_AUDIO_FORMAT_FLAG_COMPLEX | complex layout |
GST_AUDIO_FORMAT_FLAG_UNPACK | the format can be used in GstAudioFormatUnpack and GstAudioFormatPack functions |

### struct GstAudioFormatInfo

    struct GstAudioFormatInfo {
      GstAudioFormat format;
      const gchar *name;
      const gchar *description;
      GstAudioFormatFlags flags;
      gint endianness;
      gint width;
      gint depth;
      guint8 silence[8];

      GstAudioFormat unpack_format;
      GstAudioFormatUnpack unpack_func;
      GstAudioFormatPack pack_func;
    };

Information for an audio format.

#### Members

GstAudioFormat `format`; | GstAudioFormat |
const gchar *`name`; | string representation of the format |
const gchar *`description`; | user readable description of the format |
GstAudioFormatFlags `flags`; | GstAudioFormatFlags |
gint `endianness`; | the endianness |
gint `width`; | amount of bits used for one sample |
gint `depth`; | amount of valid bits in `width` |
guint8 `silence`[8]; | `width` /8 bytes with 1 silent sample |
GstAudioFormat `unpack_format`; | the format of the unpacked samples |
GstAudioFormatUnpack `unpack_func`; | function to unpack samples |
GstAudioFormatPack `pack_func`; | function to pack samples |

### struct GstAudioInfo

    struct GstAudioInfo {
      const GstAudioFormatInfo *finfo;
      GstAudioFlags             flags;
      GstAudioLayout            layout;
      gint                      rate;
      gint                      channels;
      gint                      bpf;
      GstAudioChannelPosition   position[64];
    };

Information describing audio properties. This information can be filled in from GstCaps with `gst_audio_info_from_caps()`.

Use the provided macros to access the info in this structure.

#### Members

const GstAudioFormatInfo *`finfo`; | the format info of the audio |
GstAudioFlags `flags`; | additional audio flags |
GstAudioLayout `layout`; | audio layout |
gint `rate`; | the audio sample rate |
gint `channels`; | the number of channels |
gint `bpf`; | the number of bytes for one frame, this is the size of one sample * `channels` |
GstAudioChannelPosition `position`[64]; | the positions for each channel |

### enum GstAudioLayout

Layout of the audio samples for the different channels.

#### Members

GST_AUDIO_LAYOUT_INTERLEAVED | interleaved audio |
GST_AUDIO_LAYOUT_NON_INTERLEAVED | non-interleaved audio |

### enum GstAudioPackFlags

The different flags that can be used when packing and unpacking.

#### Members

GST_AUDIO_PACK_FLAG_NONE | No flag |

### GST_META_TAG_AUDIO_STR

    #define GST_META_TAG_AUDIO_STR "audio"

This metadata is relevant for audio streams.

Since 1.2

### GST_META_TAG_AUDIO_CHANNELS_STR

    #define GST_META_TAG_AUDIO_CHANNELS_STR "channels"

This metadata stays relevant as long as channels are unchanged.

Since 1.2

### GST_AUDIO_RATE_RANGE

    #define GST_AUDIO_RATE_RANGE "(int) [ 1, max ]"

Maximum range of allowed sample rates, for use in template caps strings.

### GST_AUDIO_CHANNELS_RANGE

    #define GST_AUDIO_CHANNELS_RANGE "(int) [ 1, max ]"

Maximum range of allowed channels, for use in template caps strings.

### GST_AUDIO_FORMATS_ALL

    #define             GST_AUDIO_FORMATS_ALL

List of all audio formats, for use in template caps strings.

### GST_AUDIO_DEF_RATE

    #define GST_AUDIO_DEF_RATE 44100

Standard sampling rate used in consumer audio.

### GST_AUDIO_DEF_CHANNELS

    #define GST_AUDIO_DEF_CHANNELS 2

Standard number of channels used in consumer audio.

### GST_AUDIO_DEF_FORMAT

    #define GST_AUDIO_DEF_FORMAT "S16LE"

Standard format used in consumer audio.